% save image acquisition and processing parameters in fireCamPars.mat

sys = 'fireCamCalibrationModel';

%% Get parameters from fireCamCalibrationModel

matFile = 'fireCamPars.mat';

if exist('fireCamPars.mat','file')
    load(matFile)

    % image acquisition
    set_param([sys,'/shutSpeed'],'Value',num2str(fireCamPars.shutSpeed));
    set_param([sys,'/wbBlue'],'Value',num2str(fireCamPars.wbBlue));
    set_param([sys,'/wbRed'],'Value',num2str(fireCamPars.wbRed));
    set_param([sys,'/camGain'],'Value',num2str(fireCamPars.camGain));

    % shape determination
    set_param([sys,'/treshHue'],'Value',num2str(fireCamPars.treshHue));
    set_param([sys,'/treshSat'],'Value',num2str(fireCamPars.treshSat));
    set_param([sys,'/refDist'],'Value',num2str(fireCamPars.refDist));
    set_param([sys,'/tipDist'],'Value',num2str(fireCamPars.tipDist));
    set_param([sys,'/bendDist'],'Value',num2str(fireCamPars.bendDist));
    set_param([sys,'/minPixMark'],'Value',num2str(fireCamPars.minPixMark));
    set_param([sys,'/ROIx'],'Value',num2str(fireCamPars.ROIx));
    set_param([sys,'/ROIy'],'Value',num2str(fireCamPars.ROIy));
end
