% save image acquisition and processing parameters in fireCamPars.mat



%% Get parameters from fireCamCalibrationModel

sys = 'fireCamCalibrationModel';

load_system(sys);

% image acquisition
fireCamPars.shutSpeed   = str2num(get_param([sys,'/shutSpeed'],'Value'));
fireCamPars.wbBlue      = str2num(get_param([sys,'/wbBlue'],'Value'));
fireCamPars.wbRed       = str2num(get_param([sys,'/wbRed'],'Value'));
fireCamPars.camGain     = str2num(get_param([sys,'/camGain'],'Value'));

% shape determination
fireCamPars.treshHue    = str2num(get_param([sys,'/treshHue'],'Value'));
fireCamPars.treshSat    = str2num(get_param([sys,'/treshSat'],'Value'));
fireCamPars.refDist     = str2num(get_param([sys,'/refDist'],'Value'));
fireCamPars.tipDist     = str2num(get_param([sys,'/tipDist'],'Value'));
fireCamPars.bendDist    = str2num(get_param([sys,'/bendDist'],'Value'));
fireCamPars.minPixMark  = str2num(get_param([sys,'/minPixMark'],'Value'));
fireCamPars.ROIx        = str2num(get_param([sys,'/ROIx'],'Value'));
fireCamPars.ROIy        = str2num(get_param([sys,'/ROIy'],'Value'));


%% save it

save('fireCamPars.mat','fireCamPars')