/*
 * Catheter_new.c
 *
 * Code generation for function 'Catheter_new'
 *
 * C source code generated on: Thu Sep 15 10:42:08 2011
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "Catheter_new.h"
#include "HueSatVal.h"
#include "sign.h"
#include "dot.h"
#include "sortrows.h"
#include "sum.h"
#include "sort.h"
#include "ConComp.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
static void eml_li_find(const boolean_T x[50], int32_T y_data[50], int32_T
  y_sizes[1]);
static real_T rt_atan2d_snf(real_T u0, real_T u1);
static real_T rt_powd_snf(real_T u0, real_T u1);

/* Function Definitions */
static void eml_li_find(const boolean_T x[50], int32_T y_data[50], int32_T
  y_sizes[1])
{
  int32_T k;
  int32_T i;
  k = 0;
  for (i = 0; i < 50; i++) {
    if (x[i]) {
      k++;
    }
  }

  y_sizes[0] = k;
  k = 0;
  for (i = 0; i < 50; i++) {
    if (x[i]) {
      y_data[k] = i + 1;
      k++;
    }
  }
}

static real_T rt_atan2d_snf(real_T u0, real_T u1)
{
  real_T y;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = rtNaN;
  } else if (rtIsInf(u0) && rtIsInf(u1)) {
    y = atan2(u0 > 0.0 ? 1.0 : -1.0, u1 > 0.0 ? 1.0 : -1.0);
  } else if (u1 == 0.0) {
    if (u0 > 0.0) {
      y = RT_PI / 2.0;
    } else if (u0 < 0.0) {
      y = -(RT_PI / 2.0);
    } else {
      y = 0.0;
    }
  } else {
    y = atan2(u0, u1);
  }

  return y;
}

static real_T rt_powd_snf(real_T u0, real_T u1)
{
  real_T y;
  real_T d1;
  real_T d2;
  if (rtIsNaN(u0) || rtIsNaN(u1)) {
    y = rtNaN;
  } else {
    d1 = fabs(u0);
    d2 = fabs(u1);
    if (rtIsInf(u1)) {
      if (d1 == 1.0) {
        y = rtNaN;
      } else if (d1 > 1.0) {
        if (u1 > 0.0) {
          y = rtInf;
        } else {
          y = 0.0;
        }
      } else if (u1 > 0.0) {
        y = 0.0;
      } else {
        y = rtInf;
      }
    } else if (d2 == 0.0) {
      y = 1.0;
    } else if (d2 == 1.0) {
      if (u1 > 0.0) {
        y = u0;
      } else {
        y = 1.0 / u0;
      }
    } else if (u1 == 2.0) {
      y = u0 * u0;
    } else if ((u1 == 0.5) && (u0 >= 0.0)) {
      y = sqrt(u0);
    } else if ((u0 < 0.0) && (u1 > floor(u1))) {
      y = rtNaN;
    } else {
      y = pow(u0, u1);
    }
  }

  return y;
}

void Catheter_new(const real_T *Th_Hptr,
                          const real_T *Th_Sptr,
                          const real_T *refdistptr,
                          const real_T *tipdistptr,
                          const real_T *benddistptr,
                          const real_T *minPMptr,
                          const real_T *ArIntXptr,
                          const real_T *ArIntYptr,
                          const uint8_T *imgR,
                          const uint8_T *imgG,
                          const uint8_T *imgB,
                          real_T *alpha,
                          real_T *beta,
                          real_T *xtip,
                          real_T *ytip,
                          real_T *extpt_x,
                          real_T *extpt_y,
                          real_T *Area1,
                          real_T *Area2,
                          real_T *Area3,
                          real_T *Area4,
                          real_T *WeightedCentroids)
{
  real_T Th_H=*Th_Hptr;
  real_T Th_S=*Th_Sptr;
  real_T refdist=*refdistptr;
  real_T tipdist=*tipdistptr;
  real_T benddist=*benddistptr; 
  real_T minPM=*minPMptr;     
  real_T ArIntX=*ArIntXptr;
  real_T ArIntY=*ArIntYptr;
 
  real_T XAint;
  real_T YAint;
  real_T XminAI;
  real_T XmaxAI;
  real_T YminAI;
  static uint8_T grey_outimag[307200];
  int32_T i0;
  real_T extpt[2];
  real_T d2;
  uint8_T b_imgR[3];
  real_T Color[3];
  real_T d0;
  uint8_T u0;
  uint8_T u1;
  uint8_T u2;
  real_T b_XminAI[2];
  real_T b_YminAI[2];
  real_T WeightedCentroidsNS[100];
  real_T Areas[50];
  real_T indAr[50];
  int32_T align;
  int32_T b_indAr;
  int32_T c_indAr;
  int32_T d_indAr;
  boolean_T keepers[50];
  int32_T tmp_data[50];
  int32_T loc_sizes[2];
  real_T loc_data[100];
  real_T orvec1[2];
  real_T orvec2[2];
  real_T tilt[4];
  real_T b_tilt[2];

  /* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
  /*  This function detects the shape of a steerable catheter, based on 4     % */
  /*  markers which are attached to shaft and tip                             % */
  /*                                                                          % */
  /*  Markers are numbered from 1-4 from the bottom up                        % */
  /*                                                                          % */
  /*  Input parameters:                                                       %                                                          */
  /*  Th_H      = Hue threshold. Default = 0.1                                % */
  /*  Th_S      = Saturation threshold. Default = 0.3                         % */
  /*  refdist   = Reference distance [mm] between marker 3 and 4              % */
  /*  tipdist   = Distance [mm] between marker 4 and tip                      % */
  /*  benddist  = Distance [mm] between marker 2 and beginning of bending part% */
  /*                                                                          % */
  /*  Output parameters:                                                      % */
  /*  alpha     = Angle between tip and shaft                                 % */
  /*  beta      = rotation of shaft with respect to vertical axis             % */
  /*  xtip      = metric x-coordinate [mm] of tip measured from marker 2      % */
  /*  ytip      = metric y-coordinate [mm] of tip measured from marker 2      % */
  /*  extpt_x   = metric x-coordinate [mm] of extra point to fit circular     % */
  /*              segment measured from marker 2                              % */
  /*  extpt_y   = metric y-coordinate [mm] of extra point to fit circular     % */
  /*              segment measured from marker 2                              % */
  /*                                                                          % */
  /* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
  /* % Preprocessing */
  /*  Convert RGB image to HSV image and determine size */
  /*  imgHSV = rgb2hsv(imgRGB); */
  /*  */
  if (ArIntX <= 640.0) {
    XAint = ArIntX;
  } else {
    XAint = 640.0;
  }

  if (ArIntY <= 480.0) {
    YAint = ArIntY;
  } else {
    YAint = 480.0;
  }

  XminAI = floor(320.0 - XAint / 2.0);
  XmaxAI = floor(320.0 + XAint / 2.0);
  YminAI = floor(240.0 - YAint / 2.0);
  XAint = floor(240.0 + YAint / 2.0);

  /*  Allocation of matrices and variables */
  /*  grey_outimag=uint8(255*ones(X,Y)); */
  memset((void *)&grey_outimag[0], 0, 307200U * sizeof(uint8_T));

  /*  bin_outimag=uint8(zeros(X,Y)); */
  for (i0 = 0; i0 < 2; i0++) {
    extpt[i0] = 0.0;
  }

  /*  gam=double(0); */
  /*  phi=double(0); */
  /*  circm=double(0); */
  /*  circ=double(0); */
  /*  HSV marker detection. If pixel belongs to marker, binary pixel := 1 */
  for (YAint = XminAI; YAint <= XmaxAI; YAint++) {
    for (d2 = YminAI; d2 <= XAint; d2++) {
      b_imgR[0] = imgR[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))];
      b_imgR[1] = imgG[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))];
      b_imgR[2] = imgB[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))];
      HueSatVal(b_imgR, Color);
      if (Color[1] > Th_S) {
        if (Color[0] < Th_H) {
          d0 = 0.11 * (real_T)imgB[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))];
          d0 = floor(d0 + 0.5);
          i0 = (int32_T)d0;
          u0 = (uint8_T)i0;
          d0 = 0.59 * (real_T)imgG[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))];
          d0 = floor(d0 + 0.5);
          i0 = (int32_T)d0;
          u1 = (uint8_T)i0;
          d0 = 0.3 * (real_T)imgR[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))];
          d0 = floor(d0 + 0.5);
          i0 = (int32_T)d0;
          u2 = (uint8_T)i0;
          i0 = (int32_T)((uint32_T)(uint8_T)(u2 + u1) + (uint32_T)u0);
          if ((uint32_T)i0 > 255U) {
            i0 = 255;
          }

          grey_outimag[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))] = (uint8_T)
            i0;
        } else {
          if (1.0 - Color[0] < Th_H) {
            d0 = 0.11 * (real_T)imgB[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))];
            d0 = floor(d0 + 0.5);
            i0 = (int32_T)d0;
            u0 = (uint8_T)i0;
            d0 = 0.59 * (real_T)imgG[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))];
            d0 = floor(d0 + 0.5);
            i0 = (int32_T)d0;
            u1 = (uint8_T)i0;
            d0 = 0.3 * (real_T)imgR[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))];
            d0 = floor(d0 + 0.5);
            i0 = (int32_T)d0;
            u2 = (uint8_T)i0;
            i0 = (int32_T)((uint32_T)(uint8_T)(u2 + u1) + (uint32_T)u0);
            if ((uint32_T)i0 > 255U) {
              i0 = 255;
            }

            grey_outimag[(int32_T)((YAint - 1.0) + 640.0 * (d2 - 1.0))] =
              (uint8_T)i0;
          }
        }
      }

      /*          if ((Color(1)<Th_H || (1-Color(1))<Th_H) && Color(2)>Th_S ) */
      /*  %             grey_outimag(i,j)= imgHSV(i,j,3); */
      /*              grey_outimag(i,j) = 0.3*imgR(i,j) + 0.59*imgG(i,j) +... */
      /*                  0.11*imgB(i,j); */
      /*  %             bin_outimag(i,j)=255; */
      /*          end */
    }
  }

  /* % Identify white objects in binary image */
  /*  Find and label connected components in binary image and calculate area of  */
  /*  those objects */
  b_XminAI[0] = XminAI;
  b_XminAI[1] = XmaxAI;
  b_YminAI[0] = YminAI;
  b_YminAI[1] = XAint;
  ConComp(b_XminAI, b_YminAI, grey_outimag, Areas, WeightedCentroidsNS, &XAint);
  sort(Areas, indAr);
  *Area1 = Areas[0];
  *Area2 = Areas[1];
  *Area3 = Areas[2];
  *Area4 = Areas[3];
  memset((void *)&WeightedCentroids[0], 0, sizeof(real_T) << 3);
  align = (int32_T)indAr[0];
  b_indAr = (int32_T)indAr[1];
  c_indAr = (int32_T)indAr[2];
  d_indAr = (int32_T)indAr[3];
  for (i0 = 0; i0 < 2; i0++) {
    WeightedCentroids[i0 << 2] = WeightedCentroidsNS[(align + 50 * i0) - 1];
    WeightedCentroids[1 + (i0 << 2)] = WeightedCentroidsNS[(b_indAr + 50 * i0) -
      1];
    WeightedCentroids[2 + (i0 << 2)] = WeightedCentroidsNS[(c_indAr + 50 * i0) -
      1];
    WeightedCentroids[3 + (i0 << 2)] = WeightedCentroidsNS[(d_indAr + 50 * i0) -
      1];
  }

  /*  Remove objects with an area smaller than minPM pixels */
  for (i0 = 0; i0 < 50; i0++) {
    keepers[i0] = (Areas[i0] > minPM);
  }

  if ((sum(keepers) >= 4.0) && (XAint == 0.0)) {
    /*     %% Find centers of objects and determine orientation */
    /* Find objects' centers and add to position and location vectors */
    /*  Locations of weighted centre positions */
    eml_li_find(keepers, tmp_data, &align);
    loc_sizes[0] = align;
    loc_sizes[1] = 2;
    for (i0 = 0; i0 < 2; i0++) {
      b_indAr = align - 1;
      for (c_indAr = 0; c_indAr <= b_indAr; c_indAr++) {
        loc_data[c_indAr + loc_sizes[0] * i0] = WeightedCentroids
          [(tmp_data[c_indAr] + (i0 << 2)) - 1];
      }
    }

    sortrows(loc_data, loc_sizes);

    /* X-positions of weighted centers */
    /* Y-positions of weighted centers */
    /*  Determine orientation of vectors between markers (1-2) and (3-4) */
    /*  and find intersection point of those straight parts */
    orvec1[0] = loc_data[1] - loc_data[0];
    orvec1[1] = loc_data[1 + loc_sizes[0]] - loc_data[loc_sizes[0]];
    orvec2[0] = loc_data[3] - loc_data[2];
    orvec2[1] = loc_data[3 + loc_sizes[0]] - loc_data[2 + loc_sizes[0]];
    XmaxAI = orvec1[1] / orvec1[0];

    /* Slope of vector 1 (dy/dx) */
    XAint = loc_data[loc_sizes[0]] - XmaxAI * loc_data[0];

    /* Offset of vector 1 */
    XminAI = orvec2[1] / orvec2[0];

    /* Slope of vector 2 (dy/dx) */
    YAint = loc_data[2 + loc_sizes[0]] - XminAI * loc_data[2];

    /* Offset of vector 2 */
    if ((orvec1[0] == 0.0) && (orvec2[0] != 0.0)) {
      YminAI = loc_data[2];
      XAint = YAint + XminAI * loc_data[2];
    } else if ((orvec2[0] == 0.0) && (orvec1[0] != 0.0)) {
      YminAI = loc_data[1];
      XAint += XmaxAI * loc_data[1];
    } else if ((orvec1[0] == 0.0) && (orvec2[0] == 0.0)) {
      YminAI = loc_data[1];
      XAint = (loc_data[1 + loc_sizes[0]] + loc_data[2 + loc_sizes[0]]) / 2.0;
    } else {
      YminAI = (XAint - YAint) / (XminAI - XmaxAI);
      XAint += XmaxAI * YminAI;
    }

    /* Intersection point of straight parts */
    /*  Check if straight parts line up correctly */
    if ((XAint <= loc_data[2 + loc_sizes[0]]) || (XAint >= loc_data[1 +
         loc_sizes[0]])) {
      align = 0;
    } else {
      align = 1;
    }

    /*     %% Tilt detected shape to align shaft vertically */
    /* Determine tilt angle beta */
    *beta = rt_atan2d_snf(loc_data[1] - loc_data[0], loc_data[loc_sizes[0]] -
                          loc_data[1 + loc_sizes[0]]);
    tilt[0] = cos(-*beta);
    tilt[2] = -sin(-*beta);
    tilt[1] = sin(-*beta);
    tilt[3] = cos(-*beta);

    /*  rotate tip */
    /*  Determine lengths of both vectors and calculate angle alpha */
    *alpha = acos(dot(orvec1, orvec2) / (sqrt(rt_powd_snf(orvec1[0], 2.0) +
      rt_powd_snf(orvec1[1], 2.0)) * sqrt(rt_powd_snf(orvec2[0], 2.0) +
      rt_powd_snf(orvec2[1], 2.0)))) * 360.0 / 6.2831853071795862;
    b_XminAI[0] = loc_data[3];
    b_XminAI[1] = loc_data[3 + loc_sizes[0]];
    orvec1[0] = loc_data[2];
    orvec1[1] = loc_data[2 + loc_sizes[0]];
    for (i0 = 0; i0 < 2; i0++) {
      b_YminAI[i0] = 0.0;
      for (c_indAr = 0; c_indAr < 2; c_indAr++) {
        b_YminAI[i0] += tilt[i0 + (c_indAr << 1)] * b_XminAI[c_indAr];
      }

      b_tilt[i0] = 0.0;
      for (c_indAr = 0; c_indAr < 2; c_indAr++) {
        b_tilt[i0] += tilt[i0 + (c_indAr << 1)] * orvec1[c_indAr];
      }
    }

    if (b_YminAI[0] < b_tilt[0]) {
      *alpha = -*alpha;
    }

    /*     %% Estimate bending part */
    /*  Add extra point to compensate for unequal  */
    /*  distances to intersection point (from markers 2 and 3) */
    if (align == 1) {
      YAint = sqrt(rt_powd_snf(loc_data[1] - YminAI, 2.0) + rt_powd_snf
                   (loc_data[1 + loc_sizes[0]] - XAint, 2.0));
      d2 = sqrt(rt_powd_snf(loc_data[2] - YminAI, 2.0) + rt_powd_snf(loc_data[2
                 + loc_sizes[0]] - XAint, 2.0));
      if (YAint > d2) {
        /*  Add extra point between intersection point and */
        /*  marker 2. "p" at the end of the parameter refers */
        /*  to perpendicular line to that vector */
        d0 = XmaxAI;
        b_sign(&d0);
        extpt[0] = YminAI + d0 * d2 / sqrt(1.0 + rt_powd_snf(XmaxAI, 2.0));
        extpt[1] = XAint + d2 / sqrt(1.0 + rt_powd_snf(1.0 / XmaxAI, 2.0));

        /*  Point furthest away from intersection point (2 or 3) */
        /*   */
      } else if (d2 > YAint) {
        /*  Add extra point between intersection point and */
        /*  marker 3. "p" at the end of the parameter refers */
        /*  to perpendicular line to that vector */
        d0 = XminAI;
        b_sign(&d0);
        extpt[0] = YminAI - d0 * YAint / sqrt(1.0 + rt_powd_snf(XminAI, 2.0));
        extpt[1] = XAint - YAint / sqrt(1.0 + rt_powd_snf(1.0 / XminAI, 2.0));

        /*  Point furthest away from intersection point (2 or 3) */
        /*   */
        /*  "p" at the end of the parameter refers */
        /*  to perpendicular line to that vector */
      } else {
        extpt[0] = -1.0;

        /*  No extra point needed */
      }

      /*  Determine intersection point of perpendicular lines to find */
      /*  center of circular segment */
      /*          circm   = [     intx_p; */
      /*                          inty_p    ]; */
      /*          % Check if a circular segment can be used and if possible determine */
      /*          % radius of that segment */
      /*          if extpt(1) ~= -1  */
      /*              rad = sqrt((circm(1)-extpt(1))^2 + (circm(2)-extpt(2))^2); */
      /*          else */
      /*              rad = sqrt((circm(1)-x(2))^2 + (circm(2)-y(2))^2); */
      /*          end */
      /*          % Determine angle of circular segment that is needed */
      /*          if extpt(1) ~= -1       */
      /*              if sl2p > sl1p */
      /*                  gam  = atan2(orvec2p(2),orvec2p(1))-... */
      /*                  atan2(orvec1p(2),orvec1p(1)); */
      /*              elseif sl1p > sl2p */
      /*                  gam  = atan2(orvec1p(2),orvec1p(1))-... */
      /*                  atan2(orvec2p(2),orvec2p(1)); */
      /*              end */
      /*          end */
      /*          % Determine points on the circular segment */
      /*          if sl2 < 0 */
      /*              phi  = pi + atan(sl1p):0.005:pi + gam + atan(sl1p); */
      /*          elseif sl2 > 0 */
      /*              phi  = atan(sl1p):-0.005:-gam+atan(sl1p); */
      /*          end */
      /*          circ = circle(rad,circm(1),circm(2),phi); */
    } else {
      extpt[0] = -1.0;
    }

    /* Determine rotated positions of dots and location vector */
    /*  */
    /*  */
    /*  Determine rotated intersection point, extra point and circular */
    /*  segment. "r" at the end of the parameter refers to rotated versions  */
    /*  of points or vectors over an angle beta */
    /*  */
    /*      if align == 1 */
    /*          circmr  = tilt*circm; % */
    /*   */
    /*          circsz = size(circ); */
    /*          circr = zeros(circsz); */
    /*          for i = 1:circsz(2) */
    /*              circr(:,i) = tilt*circ(:,i); */
    /*          end */
    /*      end */
    /*     %% Calculate metric tip position (x,y) [mm] with respect to the shaft */
    /*  refdist   = distance used as a reference (between markers 3 and 4) */
    /*  tipdist   = distance between marker 4 and tip */
    /*  benddist  = distance between marker 2 and bending part         */
    /*  Define reference distance in terms of pixels (distpix) and use this */
    /*  measure to calculate tip and bend distances in pixels */
    XmaxAI = refdist / sqrt(rt_powd_snf(loc_data[2] - loc_data[3], 2.0) +
      rt_powd_snf(loc_data[2 + loc_sizes[0]] - loc_data[3 + loc_sizes[0]], 2.0));

    /*  [mm/pixel] */
    YAint = tipdist / XmaxAI;

    /*  Calculate (x,y) pixel distances between marker 2 and bending part and */
    /*  between marker 4 and tip */
    d0 = XminAI;
    b_sign(&d0);
    XAint = -d0 * sqrt(rt_powd_snf(YAint, 2.0) / (rt_powd_snf(XminAI, 2.0) + 1.0));
    if (orvec2[0] == 0.0) {
    } else {
      YAint = fabs(XminAI * XAint);
    }

    /* (x,y) tip position with respect to marker 2 [pixels] */
    /* (x,y) tip position with respect to marker 2 [mm] */
    *xtip = ((loc_data[3] + XAint) - loc_data[1]) * XmaxAI;
    *ytip = (loc_data[1 + loc_sizes[0]] - (loc_data[3 + loc_sizes[0]] - YAint)) *
      XmaxAI;

    /* (x,y) tip position with respect to base (0,0) [pixels] */
    /*  */
    /*  */
    /*  (x,y) position of extra point for circle segment [mm] */
    if ((align == 1) && (extpt[0] != -1.0)) {
      *extpt_x = (extpt[0] - loc_data[1]) * XmaxAI;
      *extpt_y = (loc_data[1 + loc_sizes[0]] - extpt[1]) * XmaxAI;
    } else {
      *extpt_x = 0.0;
      *extpt_y = 0.0;
    }

    /*     %% Display results */
    /*  Angle alpha and (x,y) tip position with respect to marker 2 [mm] */
    /*      disp(['Angle alpha is ',num2str(alpha),' degrees']) */
    /*      disp(['(x,y) position is ','(',num2str(xtip),',',... */
    /*          num2str(ytip),')',' mm']) */
  } else {
    /*     %% If detection failed, return zeros */
    *alpha = 0.0;
    *beta = 0.0;
    *xtip = 0.0;
    *ytip = 0.0;
    *extpt_x = 0.0;
    *extpt_y = 0.0;

    /*      disp(['Detection failed']) */
  }
}

/* End of code generation (Catheter_new.c) */
