/*
 * HueSatVal.c
 *
 * Code generation for function 'HueSatVal'
 *
 * C source code generated on: Thu Sep 15 10:42:08 2011
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "Catheter_new.h"
#include "HueSatVal.h"
#include "max.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */

/* Function Definitions */
void HueSatVal(const uint8_T img[3], real_T Color[3])
{
  int32_T itmp;
  real32_T b_img[3];
  real32_T r;
  real32_T g;
  real32_T b;
  real32_T b_r[3];
  real32_T rgb_max;
  real32_T val;
  real32_T mtmp;
  int32_T ix;
  boolean_T guard1 = FALSE;
  boolean_T searchingForNonNaN;
  int32_T k;
  boolean_T exitg1;
  real32_T sat;
  real_T hue;

  /* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
  /*                                                                          % */
  /*  This program transforms an image in rgb space to hsv space              % */
  /*  pixel by pixel                                                          % */
  /*                                                                          % */
  /* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
  /*  [M,N,I]=size(img); */
  /*  HSVimg = zeros(M,N,I); */
  for (itmp = 0; itmp < 3; itmp++) {
    Color[itmp] = 0.0;
    b_img[itmp] = (real32_T)img[itmp];
  }

  r = b_img[0] / 255.0F;
  g = b_img[1] / 255.0F;
  b = b_img[2] / 255.0F;

  /*  rgb_min = min([r,g,b]); */
  b_r[0] = r;
  b_r[1] = g;
  b_r[2] = b;
  rgb_max = b_max(b_r);

  /*  Compute value */
  val = rgb_max;

  /*  Compute Saturation */
  if ((real_T)rgb_max != 0.0) {
    r /= rgb_max;
    g /= rgb_max;
    b /= rgb_max;
    b_img[0] = r;
    b_img[1] = g;
    b_img[2] = b;
    mtmp = b_img[0];
    itmp = 1;
    ix = 0;
    guard1 = FALSE;
    if (rtIsNaNF(b_img[0])) {
      searchingForNonNaN = TRUE;
      k = 2;
      exitg1 = 0U;
      while ((exitg1 == 0U) && (k < 4)) {
        ix++;
        if (!rtIsNaNF(b_img[ix])) {
          mtmp = b_img[ix];
          itmp = k;
          searchingForNonNaN = FALSE;
          exitg1 = 1U;
        } else {
          k++;
        }
      }

      if (searchingForNonNaN) {
      } else {
        guard1 = TRUE;
      }
    } else {
      guard1 = TRUE;
    }

    if (guard1 == TRUE) {
      while (itmp + 1 < 4) {
        if (b_img[itmp] < mtmp) {
          mtmp = b_img[itmp];
        }

        itmp++;
      }
    }

    b_r[0] = r;
    b_r[1] = g;
    b_r[2] = b;
    rgb_max = b_max(b_r);
    sat = rgb_max - mtmp;
    if ((real_T)sat == 0.0) {
      hue = 0.0;
    } else {
      r = (r - mtmp) / (rgb_max - mtmp);
      g = (g - mtmp) / (rgb_max - mtmp);
      b = (b - mtmp) / (rgb_max - mtmp);

      /*          rgb_min = min([r,g,b]); */
      b_r[0] = r;
      b_r[1] = g;
      b_r[2] = b;
      rgb_max = b_max(b_r);

      /*  Compute Hue */
      if (rgb_max == r) {
        r = 60.0F * (g - b);
        if ((real_T)r < 0.0) {
          r += 360.0F;
        }
      } else if (rgb_max == g) {
        r = 120.0F + 60.0F * (b - r);
      } else {
        r = 240.0F + 60.0F * (r - g);
      }

      hue = (real_T)(r / 360.0F);
    }

    Color[0] = (real_T)(real32_T)hue;
    Color[1] = (real_T)sat;
    Color[2] = (real_T)val;
  }
}

/* End of code generation (HueSatVal.c) */
