% load signal data from PITON_signalLog.dat as MAT-file

load PITON_signalLog.dat

nwFileNameBase = 'PITON_signalLog';

%% set indices

ind.ImgTime      = 1;
ind.Alpha        = 2;
ind.Beta         = 3;
ind.XTip         = 4;
ind.YTip         = 5;
ind.XExtPt       = 6;
ind.YExtPt       = 7;
ind.FRefLinMotor = 8;
ind.XLinMotor    = 9;
ind.VoltInput    = 10;
ind.RealTime     = 11;


%% store as structure

signals.imgTime         = PITON_signalLog(:,ind.ImgTime);
signals.alpha           = PITON_signalLog(:,ind.Alpha);
signals.beta            = PITON_signalLog(:,ind.Beta);
signals.xTip            = PITON_signalLog(:,ind.XTip);
signals.yTip            = PITON_signalLog(:,ind.YTip);
signals.xExtPt          = PITON_signalLog(:,ind.XExtPt);
signals.yExtPt          = PITON_signalLog(:,ind.YExtPt);
signals.forceRef        = PITON_signalLog(:,ind.FRefLinMotor);
signals.xLinMotor       = PITON_signalLog(:,ind.XLinMotor);
signals.voltInput       = PITON_signalLog(:,ind.VoltInput);
signals.realTime        = PITON_signalLog(:,ind.RealTime);


%% save as MAT-file

success = 0;
i = 1;

while success == 0
    if ~exist([nwFileNameBase,'_',num2str(i),'.mat'],'file')
        save([nwFileNameBase,'_',num2str(i)],'signals')
        success = 1;
    end
    i = i+1;
end

clear success ind signals nwFileNameBase i PITON_signalLog